unit uInterface;

interface

uses Windows, Messages, KOL;

const
  PluginCopyright   = 'Copyright  2009 dss';
  PluginInformation = ''{   +#13#10+
                      'dss@mmbuilder.ru' +#13#10+
                      '_dss@mail.ru'  }
                      ;

procedure SendScriptCommand(Str: string; NoError: Boolean = True);
procedure CallMMB(CallOnUp, CallOnDown: Boolean);

var
  hMMBWindow: Cardinal;
  AppDir: string = '';   
  TextInput: array [1..5] of string = ('','','','','');
  TextOutput: string = '';
  NumInput: array [1..5] of Integer = (0,0,0,0,0);
  NumOutput: Integer = 0;
  PPGetStr: string = '';
  PPSetStr: string = '';
  InitPlugin: string;
  SC_MX, SC_MY: Integer;
  CanvRect: TRect;

implementation

uses uWndProc;

function Copyright: pChar; cdecl;
begin
  Result := pChar(PluginCopyright);
end;

function GetInfo: pChar; cdecl;
begin
  Result := pChar(PluginInformation);
end;

procedure SetPath(sPath: pChar); cdecl;
begin
  AppDir := sPath;
end;


procedure SetParentWindow(hwnd: HWND); cdecl;
begin
  hMMBWindow := hwnd;
  ChangeWndProc;




  //Form creation here...
end;

procedure Draw(pDC: HDC; x, y, nWidth, nHeight: Integer); cdecl;
begin
  SC_MX := x;
  SC_MY := y;

  CanvRect.Left   := x;
  CanvRect.Top    := y;
  CanvRect.Right  := x + nWidth;
  CanvRect.Bottom := y + nHeight;
  //if Assigned(Host) then Host.BoundsRect := CanvRect;
end;

procedure SetFile(s: pChar); cdecl;
var
  i: Integer;
begin
  for i := High(TextInput) downto Low(TextInput) + 1 do
    TextInput[i] := TextInput[i - 1];
  TextInput[Low(TextInput)] := s;
end;

function GetFile: pChar; cdecl;
begin
  Result := pChar(TextOutput);
end;

procedure SetData(nData: Integer); cdecl;
var
  i: Integer;
begin
  for i := High(NumInput) downto Low(NumInput) + 1 do
    NumInput[i] := NumInput[i - 1];
  NumInput[Low(NumInput)] := nData;
end;

function GetData: Integer; cdecl;
begin
  Result := NumOutput;
end;

function CaptureMouse: integer; cdecl;
begin
  Result := 0;
end;

procedure MouseMove(X, Y: integer); cdecl;
begin
  //
end;

procedure MouseDown(X, Y: integer); cdecl;
begin
  //
end;

procedure MouseUp(X, Y: integer); cdecl;
begin
  //
end;

procedure RMouseDown(X, Y: integer); cdecl;
begin
  //
end;

procedure RMouseUp(X, Y: integer); cdecl;
begin
  //
end;

procedure SendScriptCommand(Str: string; NoError: Boolean = True);
begin
  SendMessage(hMMBWindow, $08C7, Integer(not NoError), LPARAM(LPCTSTR(str)));
end;

procedure CallMMB(CallOnUp, CallOnDown: Boolean);
var
  i: Integer;
begin
  i := (SC_MY * 65536)+ SC_MX;
  //     
  if CallOnDown then PostMessage(hMMBWindow, WM_LBUTTONDOWN, $00000001, i);
  if CallOnUp then PostMessage(hMMBWindow, WM_LBUTTONUP, $00000000, i);
end;

exports
  Copyright,
  GetInfo,
  SetPath,
  SetParentWindow,
//  Draw,
  SetFile,
  GetFile,
  SetData,
  GetData
{  CaptureMouse,
  MouseMove,
  MouseDown,
  MouseUp,
  RMouseDown,
  RMouseUp   }


  ;


end.
