unit uWndProc;

interface

uses Windows, Messages, KOL;

function NewWinProc (Handle: THandle; Msg, wParam, lParam: LongInt): LongInt; stdcall;
procedure ChangeWndProc;
procedure ReturnWndProc;

var
  OldWndProc: Pointer = nil;

implementation

uses uInterface, uFunctions;

function NewWinProc(Handle: THandle; Msg, wParam, lParam: LongInt): LongInt; stdcall;
begin
  case Msg of
  
    { This message comes when the window of the program is closed }
    WM_DESTROY: 
    begin
      //Do something
      //...
    
      //Return old window procedure
      ReturnWndProc;
    end;

    { Some other useful messages:
      WM_ACTIVATEAPP
      WM_QUERYOPEN
      WM_QUERYENDSESSION
      ...       }
    
  else
  end;
  { Call the old window procedure }
  Result := CallWindowProc(OldWndProc, Handle, Msg, wParam, lParam);
end;

procedure ChangeWndProc;
begin
  OldWndProc := Pointer(SetWindowLong(hMMBWindow, gwl_WndProc, LongInt (@NewWinProc)));
end;

procedure ReturnWndProc;
begin
  SetWindowLong(hMMBWindow, gwl_WndProc, LongInt (OldWndProc))
end;

end.
